/*
Variant of : send_list.hh

Description:
------------
same code, but without the acknowledgment message. 
Illustrates one of the differences with Sing\#: we can treat unbounded
channels.
*/


message cell     [val|->]
message close_me [val|->C{end} * val==src]

contract C {
  initial state start { !cell -> start;
                           !close_me -> end; }
  final state end {}
}

putter(e,x) [e|->C{start} * list(x)] {
  local t;

  while(x != NULL) [e|->C{start} * list(x)] {
      t = x->tl;
      send(cell,e,x);
      x = t;
    }
  send(close_me,e,e);
} [emp]

getter(f) [f|->~C{start}] {
  local x, e;

  e = NULL;
  while(e == NULL) [if e==NULL then f|->~C{start} else e|->C{end} * f|->~C{end},pr:e] {
    switch receive {
    x = receive(cell,f): { dispose(x);}
    e = receive(close_me,f): {}
    }
  }
  close(f,e);
} [emp]

send_list(x) [list(x)] {
  local e,f;
  
  (e,f) = open(C);
  putter(e,x) || getter(f);
} [emp]
